﻿Imports System
Imports System.IO
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Navigation

Partial Public Class Window1
	Public Sub New()
		MyBase.New()

		Me.InitializeComponent()

		' Insert code required on object creation below this point.
	End Sub

    ' Start the animation.
    Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        ' Get geometry info.
        Dim ball_wid As Double = ellBall.ActualWidth
        Dim ball_hgt As Double = ellBall.ActualHeight
        Dim max_x As Integer = canTable.ActualWidth - ball_wid
        Dim max_y As Integer = canTable.ActualHeight - ball_hgt

        ' Set the ball's initial position.
        Dim rand As New Random()
        Dim x As Double = rand.Next(0, max_x)
        Dim y As Double = rand.Next(0, max_y)
        Canvas.SetLeft(ellBall, x)
        Canvas.SetTop(ellBall, y)

        ' Make animations.
        Const TRANSIT_TIME As Double = 1
        Dim x_animation As New DoubleAnimationUsingKeyFrames()
        x_animation.RepeatBehavior = RepeatBehavior.Forever
        Dim l_time As Double = TRANSIT_TIME * x / max_x
        Dim r_time As Double = TRANSIT_TIME - l_time
        ' To right edge.
        x_animation.KeyFrames.Add( _
            New LinearDoubleKeyFrame( _
                max_x, _
                KeyTime.FromTimeSpan(TimeSpan.FromSeconds(r_time))))
        ' Back to left edge.
        x_animation.KeyFrames.Add( _
            New LinearDoubleKeyFrame( _
                0, _
                KeyTime.FromTimeSpan(TimeSpan.FromSeconds(r_time + TRANSIT_TIME))))
        ' Back to start.
        x_animation.KeyFrames.Add( _
            New LinearDoubleKeyFrame( _
                x, _
                KeyTime.FromTimeSpan(TimeSpan.FromSeconds(r_time + TRANSIT_TIME + l_time))))

        Dim y_animation As New DoubleAnimationUsingKeyFrames()
        y_animation.RepeatBehavior = RepeatBehavior.Forever
        Dim t_time As Double = TRANSIT_TIME * y / max_y
        Dim b_time As Double = TRANSIT_TIME - t_time
        ' To bottom edge.
        y_animation.KeyFrames.Add( _
            New LinearDoubleKeyFrame( _
                max_y, _
                KeyTime.FromTimeSpan(TimeSpan.FromSeconds(b_time))))
        ' Back to top edge.
        y_animation.KeyFrames.Add( _
            New LinearDoubleKeyFrame( _
                0, _
                KeyTime.FromTimeSpan(TimeSpan.FromSeconds(b_time + TRANSIT_TIME))))
        ' Back to start.
        y_animation.KeyFrames.Add( _
            New LinearDoubleKeyFrame( _
                y, _
                KeyTime.FromTimeSpan(TimeSpan.FromSeconds(b_time + TRANSIT_TIME + t_time))))

        ' Apply the animations.
        ellBall.BeginAnimation(Canvas.LeftProperty, x_animation)
        ellBall.BeginAnimation(Canvas.TopProperty, y_animation)
    End Sub

    ' Exit.
    Private Sub ellBall_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs)
        Me.Close()
    End Sub
End Class
